(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material/paginator'), require('@angular/material/sort'), require('@angular/forms'), require('@yukawa/chain-main-angular-core'), require('rxjs'), require('lodash'), require('rxjs/operators'), require('@angular/material/table'), require('@angular/material/chips'), require('ngx-color-picker'), require('@ngx-translate/core'), require('@angular/common'), require('@angular/material/list'), require('@angular/material/icon'), require('@angular/material/select'), require('@angular/material/input'), require('@angular/material/button'), require('ng-click-outside'), require('@angular/flex-layout'), require('@angular/material/card'), require('@angular/material/tooltip'), require('@angular/material/toolbar'), require('@yukawa/chain-base-angular-comp'), require('@yukawa/chain-base-angular-store'), require('@angular/common/http'), require('@yukawa/chain-base-angular-client'), require('@angular/cdk/table')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-main-angular-comp', ['exports', '@angular/core', '@angular/material/paginator', '@angular/material/sort', '@angular/forms', '@yukawa/chain-main-angular-core', 'rxjs', 'lodash', 'rxjs/operators', '@angular/material/table', '@angular/material/chips', 'ngx-color-picker', '@ngx-translate/core', '@angular/common', '@angular/material/list', '@angular/material/icon', '@angular/material/select', '@angular/material/input', '@angular/material/button', 'ng-click-outside', '@angular/flex-layout', '@angular/material/card', '@angular/material/tooltip', '@angular/material/toolbar', '@yukawa/chain-base-angular-comp', '@yukawa/chain-base-angular-store', '@angular/common/http', '@yukawa/chain-base-angular-client', '@angular/cdk/table'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-main-angular-comp'] = {}), global.ng.core, global.ng.material.paginator, global.ng.material.sort, global.ng.forms, global.chainMainAngularCore, global.rxjs, global._, global.rxjs.operators, global.ng.material.table, global.ng.material.chips, global['ngx-color-picker'], global['@ngx-translate/core'], global.ng.common, global.ng.material.list, global.ng.material.icon, global.ng.material.select, global.ng.material.input, global.ng.material.button, global['ng-click-outside'], global.ng.flexLayout, global.ng.material.card, global.ng.material.tooltip, global.ng.material.toolbar, global.chainBaseAngularComp, global.chainBaseAngularStore, global.ng.common.http, global.chainBaseAngularClient, global.ng.cdk.table));
}(this, (function (exports, core, paginator, sort, forms, chainMainAngularCore, rxjs, _, operators, table, chips, ngxColorPicker, core$1, common, list, icon, select, input, button, ngClickOutside, flexLayout, card, tooltip, toolbar, chainBaseAngularComp, chainBaseAngularStore, http, chainBaseAngularClient, table$1) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var ___default = /*#__PURE__*/_interopDefaultLegacy(_);

    var TAG = 'LabelTableComponent';
    var LabelTableComponent = /** @class */ (function () {
        function LabelTableComponent() {
            this.displayedColumns = ['name'];
        }
        LabelTableComponent.prototype.ngOnInit = function () {
            console.debug(TAG, this.dataSource);
        };
        return LabelTableComponent;
    }());
    LabelTableComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'chain-main-label-table',
                    template: "<div class=\"table-layout-1\" *ngIf=\"dataSource\">\n\n  <mat-table #table [dataSource]=\"dataSource\">\n    <!-- username Column -->\n    <ng-container matColumnDef=\"name\">\n      <mat-header-cell *matHeaderCellDef>{{'HEADER.NAME' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <mat-chip-list>\n          <mat-chip [ngStyle]=\"{'background-color': row?.colorCode}\">{{row.name}}</mat-chip>\n        </mat-chip-list>\n      </mat-cell>\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\"></mat-row>\n  </mat-table>\n\n</div>\n",
                    styles: [""]
                },] }
    ];
    /** @nocollapse */
    LabelTableComponent.ctorParameters = function () { return []; };
    LabelTableComponent.propDecorators = {
        displayedColumns: [{ type: core.Input }],
        labelFilter: [{ type: core.Input }],
        dataSource: [{ type: core.Input }],
        paginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }],
        sort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }]
    };

    var LabelEditService = /** @class */ (function () {
        function LabelEditService() {
            this._labelManagementShown = new rxjs.BehaviorSubject(false);
            this._selectedLabels = new rxjs.BehaviorSubject([]);
        }
        LabelEditService.prototype.showLabelManagement = function () {
            this.labelManagementShown.next(true);
        };
        LabelEditService.prototype.hideLabelManagement = function () {
            this.labelManagementShown.next(false);
        };
        LabelEditService.prototype.toggleLabelManagement = function () {
            this.labelManagementShown.next(!this.labelManagementShown.value);
        };
        Object.defineProperty(LabelEditService.prototype, "labelManagementShown", {
            get: function () {
                return this._labelManagementShown;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LabelEditService.prototype, "selectedLabels", {
            get: function () {
                return this._selectedLabels;
            },
            enumerable: false,
            configurable: true
        });
        LabelEditService.prototype.setSelectedLabels = function (labels) {
            this.selectedLabels.next(labels);
        };
        return LabelEditService;
    }());
    LabelEditService.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    LabelEditService.ctorParameters = function () { return []; };

    var TAG$1 = "LabelingComponent";
    var LabelingComponent = /** @class */ (function () {
        function LabelingComponent(_formBuilder, labelEditService, labelAspect) {
            var _this = this;
            this._formBuilder = _formBuilder;
            this.labelEditService = labelEditService;
            this.labelAspect = labelAspect;
            this.labelAdded = new core.EventEmitter();
            this.navigateToAllLabels = new core.EventEmitter();
            this.debouncer = new rxjs.Subject();
            this.showAddLabelBox = false;
            this.debouncer.pipe(operators.debounceTime(100))
                .subscribe(function (color) { return _this.newLabel.get("colorCode").patchValue(color); });
        }
        LabelingComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.selectedLabels = this.labelEditService.selectedLabels;
            this.newLabel = this._formBuilder.group({
                name: [null, [forms.Validators.required]],
                colorCode: [null, [forms.Validators.required]]
            });
            if (!this.labelList && this.labelAspect) {
                this.labelAspect.queryLabel({ pager: { pageSize: 10000, firstResult: 0 } })
                    .subscribe(function (value) {
                    _this.labelList = value.items;
                });
            }
        };
        LabelingComponent.prototype.createNewLabel = function () {
            var _this = this;
            console.debug(TAG$1, "new label: ", this.newLabel.value);
            this.labelAspect.createLabel(this.newLabel.value)
                .subscribe(function (value) {
                _this.labelList.push(value);
                _this.labelAdded.emit(_this.newLabel.value);
                _this.newLabel.reset();
                _this.showAddLabelBox = false;
            });
        };
        LabelingComponent.prototype.deleteLabel = function (event, labelId) {
            var _this = this;
            event.stopPropagation();
            this.labelAspect.deleteLabel(labelId).subscribe(function () {
                _this.labelList.splice(_this.labelList.map(function (label) { return label.id; }).indexOf(labelId), 1);
            });
        };
        LabelingComponent.prototype.colorPickerChange = function (color) {
            this.debouncer.next(color);
        };
        LabelingComponent.prototype.compareLabels = function (label1, label2) {
            return label1.id === label2.id;
        };
        LabelingComponent.prototype.removeLabelFromSelection = function (i) {
            var copy = ___default['default'].cloneDeep(this.selectedLabels.value);
            copy.splice(i, 1);
            this.selectedLabels.next(copy);
        };
        return LabelingComponent;
    }());
    LabelingComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'chain-main-labeling',
                    template: "<!--TODO Add CSS-->\n<div id=\"labelEdit\" fxLayout=\"column\" fxLayoutGap=\"20px\">\n    <div> <!--show currently selected selectedLabels-->\n        <mat-chip-list>\n            <mat-chip *ngFor=\"let label of selectedLabels | async; let i = index\"\n                      [ngStyle]=\"{'background-color': label.colorCode}\" (removed)=\"removeLabelFromSelection(i)\">\n                {{label.name}}\n                <mat-icon matChipRemove>cancel</mat-icon>\n            </mat-chip>\n        </mat-chip-list>\n\n    </div>\n\n    <div *ngIf=\"labelEditService.labelManagementShown | async\" fxLayout=\"column\" fxLayoutGap=\"10px\">\n        <!--only visible when the edit button is clicked-->\n        <mat-form-field color=\"accent\">\n            <input matInput placeholder=\"{{'CMD.FIND' | translate}}\">\n        </mat-form-field>\n        <!--Label selection list-->\n        <div fxFlex=\"1 1 20%\">\n            <mat-selection-list #selectionList [ngModel]=\"selectedLabels | async\" [compareWith]=\"compareLabels\"\n                                class=\"select-list\"\n                                (ngModelChange)=\"selectedLabels.next($event)\">\n\n                <mat-list-option *ngFor=\"let label of labelList\" [value]=\"label\"\n                                 [ngStyle]=\"{'background-color': label.colorCode}\">\n                    <div fxLayout=\"row\" fxLayoutAlign=\"space-between\">\n                        <div>{{label.name}}</div>\n                        <mat-icon (click)=\"deleteLabel($event,label.id)\">delete</mat-icon>\n                    </div>\n\n                </mat-list-option>\n\n\n            </mat-selection-list>\n        </div>\n\n        <!--add a custom label-->\n        <div (clickOutside)=\"showAddLabelBox=false\">\n            <form [formGroup]=\"newLabel\">\n                <div class=\"field-wrap\">\n                    <mat-form-field appearance=\"outline\">\n                        <input (click)=\"showAddLabelBox=true\" [ngStyle]=\"{'color': newLabel.value.colorCode}\"\n                               formControlName=\"name\"\n                               autocomplete=\"off\"\n                               matInput placeholder=\"{{'LABEL.ADD_NEW' | translate}}\">\n                    </mat-form-field>\n\n                    <!--the options below are shown only when clicking on the ADD_NEW text field-->\n                    <div class=\"field-wrap\" *ngIf=\"showAddLabelBox\">\n                        <input autocomplete=\"new-labelinput\" matInput formControlName=\"colorCode\">\n\n                        <span [style.background]=\"pickedColor\"\n                              [cpToggle]=\"true\"\n                              [cpDialogDisplay]=\"'inline'\"\n                              [cpDisableInput]=\"true\"\n                              [(colorPicker)]=\"pickedColor\"\n                              (colorPickerChange)=\"colorPickerChange($event)\"></span>\n\n\n                        <button [disabled]=\"newLabel.invalid\" mat-button mat-raised-button (click)=\"createNewLabel()\">\n                            {{'CMD.ADD' | translate}}\n                        </button>\n\n                    </div>\n                </div>\n            </form>\n        </div>\n\n    </div>\n</div>\n",
                    providers: [LabelEditService],
                    styles: ["#labelEdit .select-list{overflow:auto;height:30vh;overflow-y:scroll}"]
                },] }
    ];
    /** @nocollapse */
    LabelingComponent.ctorParameters = function () { return [
        { type: forms.FormBuilder },
        { type: LabelEditService },
        { type: undefined, decorators: [{ type: core.Inject, args: [chainMainAngularCore.LABEL_ASPECT,] }] }
    ]; };
    LabelingComponent.propDecorators = {
        labelList: [{ type: core.Input }],
        labelAdded: [{ type: core.Output }],
        navigateToAllLabels: [{ type: core.Output }]
    };

    var ChainMainLabel = /** @class */ (function () {
        function ChainMainLabel() {
        }
        return ChainMainLabel;
    }());
    ChainMainLabel.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        LabelTableComponent,
                        LabelingComponent
                    ],
                    imports: [
                        ngxColorPicker.ColorPickerModule,
                        //     ClickOutsideModule,
                        common.CommonModule,
                        chips.MatChipsModule,
                        core$1.TranslateModule,
                        table.MatTableModule,
                        list.MatListModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        icon.MatIconModule,
                        select.MatSelectModule,
                        input.MatInputModule,
                        button.MatButtonModule,
                        ngClickOutside.ClickOutsideModule,
                        flexLayout.FlexModule
                    ],
                    exports: [
                        LabelTableComponent,
                        LabelingComponent,
                    ],
                    providers: [],
                    entryComponents: [],
                    schemas: []
                },] }
    ];

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __createBinding(o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    }
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                exports[p] = m[p];
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    result[k] = mod[k];
        result.default = mod;
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var GroupTableQueryStore = /** @class */ (function (_super) {
        __extends(GroupTableQueryStore, _super);
        function GroupTableQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        GroupTableQueryStore.prototype.queryTable = function () {
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.queryGroups(filter);
        };
        return GroupTableQueryStore;
    }(chainBaseAngularStore.QueryTableSource));

    //@Injectable({providedIn: 'root'})
    var GroupService = /** @class */ (function (_super) {
        __extends(GroupService, _super);
        function GroupService(http, configService) {
            var _this = _super.call(this, http, configService) || this;
            _this.http = http;
            _this.configService = configService;
            return _this;
        }
        // searchGroups(filter: GroupFilter): Observable<Group> {
        //   return this.http.post<Group>(this.formatServiceUrl('/search'), filter);
        // }
        GroupService.prototype.loadGroup = function (name) {
            return this.http.get(this.formatServiceUrl('/' + name));
        };
        GroupService.prototype.editGroup = function (group) {
            return this.http.post(this.formatServiceUrl('/'), group);
        };
        GroupService.prototype.queryGroups = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        GroupService.prototype.deleteGroup = function (name) {
            return this.http.delete(this.formatServiceUrl('' + name));
        };
        GroupService.prototype.updateGroup = function (group) {
            return this.http.put(this.formatServiceUrl(''), group);
        };
        GroupService.prototype.createGroup = function (value) {
            return this.editGroup(value);
        };
        GroupService.prototype.formatServiceUrl = function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.formatUrl("mainUrl") + "/groups" + path;
        };
        return GroupService;
    }(chainBaseAngularClient.RestAspect));
    GroupService.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    GroupService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: chainBaseAngularClient.ConfigService }
    ]; };

    var TAG$2 = 'GroupTableComponent';
    var GroupTableComponent = /** @class */ (function () {
        function GroupTableComponent(_service) {
            this._service = _service;
            this.displayedColumns = ['info.name', 'roles'];
            this.filter = {};
            this.showToolbar = true;
            this.action = new core.EventEmitter();
        }
        GroupTableComponent.prototype.ngOnInit = function () {
            var _this = this;
            var filter = this.filter;
            if (!this.dataSource) {
                this.dataSource = new GroupTableQueryStore(this._service, this.paginator, this.sort, filter);
            }
            console.log(TAG$2, "nativeElement", this.searchElem);
            if (this.searchElem) {
                rxjs.fromEvent(this.searchElem.nativeElement, 'keyup')
                    .pipe(operators.debounceTime(1000), operators.distinctUntilChanged())
                    .subscribe(function (event) {
                    var value = _this.searchElem.nativeElement.value;
                    if (value == '')
                        value = null;
                    // let filter = this.dataSource.filterSubject.value;
                    var filter = _this.filter;
                    filter.keyword = value;
                    console.log(TAG$2, "nativeElement change", value);
                    _this.reload();
                });
            }
        };
        GroupTableComponent.prototype.reload = function () {
            this.dataSource.reload();
        };
        GroupTableComponent.prototype.onAction = function (type, payload) {
            this.action.emit({ type: type, value: payload });
        };
        return GroupTableComponent;
    }());
    GroupTableComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'main-group-table',
                    template: "<div class=\"table-layout-1 group-table-layout\">\n\n    <ng-content></ng-content>\n\n  <mat-toolbar class=\"primary-300--bg\" fxLayoutAlign=\"space-between center\">\n    <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n    </mat-paginator>\n    <div class=\"field-wrap\">\n      <div class=\"field-box trans-icon\">\n        <input #searchField type=\"text\"/>\n        <button (click)=\"reload()\" type=\"button\">\n          <i><mat-icon>search</mat-icon></i>\n        </button>\n      </div>\n    </div>\n  </mat-toolbar>\n\n  <mat-table class=\"table-hover-1\" #table [dataSource]=\"dataSource\" matSort\n             matSortActive=\"info.name\"\n             matSortDirection=\"asc\"\n             matSortDisableClear>\n\n    <ng-container matColumnDef=\"name\">\n      <mat-header-cell mat-sort-header *matHeaderCellDef>{{'GROUPS.NAME' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span>{{row?.name}}</span></mat-cell>\n    </ng-container>\n\n    <ng-container matColumnDef=\"orgId\">\n      <mat-header-cell mat-sort-header *matHeaderCellDef>{{'GROUPS.ORG_ID' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span>{{row?.orgId}}</span></mat-cell>\n    </ng-container>\n\n    <ng-container matColumnDef=\"type\">\n      <mat-header-cell mat-sort-header *matHeaderCellDef>{{'GROUPS.TYPE' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span>{{row?.type}}</span></mat-cell>\n    </ng-container>\n\n    <ng-container  matColumnDef=\"info.name\">\n      <mat-header-cell mat-sort-header *matHeaderCellDef>{{'GROUPS.NAME' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\" [matTooltip]=\"row.info.desc||row.name\">\n        <span>{{row?.info?.name}}</span></mat-cell>\n    </ng-container>\n\n    <ng-container matColumnDef=\"roles\">\n      <mat-header-cell *matHeaderCellDef>{{'GROUPS.ROLES' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span>{{row?.roles.join(\" , \")}}</span></mat-cell>\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('select', row)\">\n    </mat-row>\n\n  </mat-table>\n\n</div>\n\n\n\n"
                },] }
    ];
    /** @nocollapse */
    GroupTableComponent.ctorParameters = function () { return [
        { type: GroupService }
    ]; };
    GroupTableComponent.propDecorators = {
        displayedColumns: [{ type: core.Input }],
        filter: [{ type: core.Input }],
        dataSource: [{ type: core.Input }],
        showToolbar: [{ type: core.Input }],
        action: [{ type: core.Output }],
        paginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }],
        sort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }],
        searchElem: [{ type: core.ViewChild, args: ['searchField', { static: true },] }]
    };

    var MainGroupModule = /** @class */ (function () {
        function MainGroupModule() {
        }
        return MainGroupModule;
    }());
    MainGroupModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$1.TranslateModule.forChild({}),
                        forms.ReactiveFormsModule,
                        card.MatCardModule,
                        table.MatTableModule,
                        tooltip.MatTooltipModule,
                        paginator.MatPaginatorModule,
                        sort.MatSortModule,
                        toolbar.MatToolbarModule,
                        button.MatButtonModule,
                        icon.MatIconModule,
                        flexLayout.FlexLayoutModule,
                        forms.FormsModule,
                        chainBaseAngularComp.ChainBaseComp
                    ],
                    declarations: [
                        GroupTableComponent
                    ],
                    exports: [
                        GroupTableComponent
                    ]
                },] }
    ];

    var UserQueryStore = /** @class */ (function (_super) {
        __extends(UserQueryStore, _super);
        function UserQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        UserQueryStore.prototype.queryTable = function () {
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.queryUser(filter);
        };
        return UserQueryStore;
    }(chainBaseAngularStore.QueryTableSource));

    // @Injectable({
    //     providedIn: 'root'
    // })
    var UserService = /** @class */ (function (_super) {
        __extends(UserService, _super);
        //Users: User[];
        function UserService(http, configService) {
            var _this = _super.call(this, http, configService) || this;
            _this.http = http;
            _this.configService = configService;
            return _this;
        }
        /** @deprecated */
        UserService.prototype.searchUser = function (filter) {
            return this.search(this.formatServiceUrl('/user'), filter);
        };
        UserService.prototype.queryUser = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        UserService.prototype.loadUser = function (id) {
            var _this = this;
            //return this.load<User>(`${this.formatServiceUrl('')}${id}`)
            return this.load(this.formatServiceUrl("/" + id))
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        UserService.prototype.saveUser = function (user, method) {
            return this.edit(this.formatServiceUrl(), user, { method: method });
        };
        UserService.prototype.deleteUser = function (username) {
            return this.http.delete(this.formatServiceUrl("/" + username));
        };
        UserService.prototype.formatServiceUrl = function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.formatUrl("mainUrl") + "/users" + path;
        };
        return UserService;
    }(chainBaseAngularClient.RestAspect));
    UserService.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    UserService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: chainBaseAngularClient.ConfigService }
    ]; };

    var TAG$3 = 'UserTableComponent';
    var UserTableComponent = /** @class */ (function () {
        function UserTableComponent(_service) {
            this._service = _service;
            this.displayedColumns = ['username', 'person.firstName', 'person.lastName', 'created.date'];
            this.filter = {};
            this.showToolbar = true;
            this.action = new core.EventEmitter();
        }
        UserTableComponent.prototype.ngOnInit = function () {
            var _this = this;
            var filter = this.filter;
            if (!this.dataSource) {
                this.dataSource = new UserQueryStore(this._service, this.paginator, this.sort, filter);
            }
            if (this.searchElem) {
                rxjs.fromEvent(this.searchElem.nativeElement, 'keyup')
                    .pipe(operators.debounceTime(1000), operators.distinctUntilChanged())
                    .subscribe(function (event) {
                    var value = _this.searchElem.nativeElement.value;
                    if (value == '')
                        value = null;
                    // let filter = this.dataSource.filterSubject.value;
                    var filter = _this.filter;
                    filter.keyword = value;
                    _this.reload();
                });
            }
        };
        UserTableComponent.prototype.reload = function () {
            this.dataSource.reload();
        };
        UserTableComponent.prototype.onAction = function (type, payload) {
            this.action.emit({ type: type, value: payload });
        };
        return UserTableComponent;
    }());
    UserTableComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'main-user-table',
                    template: "<div class=\"table-layout-1 user-table-layout\">\n\n    <ng-content></ng-content>\n\n  <mat-toolbar class=\"primary-300-bg\" fxLayoutAlign=\"space-between center\">\n    <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n    </mat-paginator>\n    <div class=\"field-wrap\">\n      <div class=\"field-box trans-icon\">\n        <input #searchField type=\"text\"/>\n        <button (click)=\"reload()\" type=\"button\">\n          <i><mat-icon>search</mat-icon></i>\n        </button>\n      </div>\n    </div>\n  </mat-toolbar>\n\n  <mat-table class=\"table-hover-1\" #table [dataSource]=\"dataSource\" matSort\n             matSortActive=\"created.date\"\n             matSortDirection=\"desc\"\n             matSortDisableClear>\n\n      <!-- username Column -->\n      <ng-container matColumnDef=\"username\">\n          <mat-header-cell mat-sort-header\n                           *matHeaderCellDef>{{'USER.HEADER.USER_NAME' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.username}}</span></mat-cell>\n      </ng-container>\n      <!-- firstName Column -->\n      <ng-container matColumnDef=\"person.firstName\">\n          <mat-header-cell mat-sort-header\n                           *matHeaderCellDef>{{'USER.HEADER.FIRST_NAME' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.person?.firstName}}</span></mat-cell>\n      </ng-container>\n\n      <!-- lastName Column -->\n      <ng-container matColumnDef=\"person.lastName\">\n          <mat-header-cell mat-sort-header\n                           *matHeaderCellDef>{{'USER.HEADER.LAST_NAME' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.person?.lastName}}</span></mat-cell>\n      </ng-container>\n      <!-- groups Column -->\n      <ng-container matColumnDef=\"groups\">\n          <mat-header-cell mat-sort-header\n                           *matHeaderCellDef>{{'USER.HEADER.GROUPS' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.groups}}</span></mat-cell>\n      </ng-container>\n\n      <!-- created date Column -->\n      <ng-container matColumnDef=\"created.date\">\n          <mat-header-cell mat-sort-header *matHeaderCellDef>{{'USER.HEADER.CREATED_DATE' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.created?.date | date:'shortDate'}}</span></mat-cell>\n      </ng-container>\n\n\n      <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('select', row)\">\n    </mat-row>\n\n  </mat-table>\n\n</div>\n\n\n\n"
                },] }
    ];
    /** @nocollapse */
    UserTableComponent.ctorParameters = function () { return [
        { type: UserService }
    ]; };
    UserTableComponent.propDecorators = {
        displayedColumns: [{ type: core.Input }],
        filter: [{ type: core.Input }],
        dataSource: [{ type: core.Input }],
        showToolbar: [{ type: core.Input }],
        action: [{ type: core.Output }],
        paginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }],
        sort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }],
        searchElem: [{ type: core.ViewChild, args: ['searchField', { static: true },] }]
    };

    var MainUserModule = /** @class */ (function () {
        function MainUserModule() {
        }
        return MainUserModule;
    }());
    MainUserModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$1.TranslateModule.forChild({}),
                        forms.ReactiveFormsModule,
                        card.MatCardModule,
                        table.MatTableModule,
                        tooltip.MatTooltipModule,
                        paginator.MatPaginatorModule,
                        sort.MatSortModule,
                        toolbar.MatToolbarModule,
                        button.MatButtonModule,
                        icon.MatIconModule,
                        flexLayout.FlexLayoutModule,
                        forms.FormsModule,
                        chainBaseAngularComp.ChainBaseComp
                    ],
                    declarations: [
                        UserTableComponent
                    ],
                    exports: [
                        UserTableComponent
                    ]
                },] }
    ];

    var SettingQueryStore = /** @class */ (function (_super) {
        __extends(SettingQueryStore, _super);
        function SettingQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        SettingQueryStore.prototype.queryTable = function () {
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.querySettings(filter);
        };
        return SettingQueryStore;
    }(chainBaseAngularStore.QueryTableSource));

    var SettingService = /** @class */ (function (_super) {
        __extends(SettingService, _super);
        function SettingService(http, configService) {
            var _this = _super.call(this, http, configService) || this;
            _this.http = http;
            _this.configService = configService;
            return _this;
        }
        // /** @deprecated */
        // searchSettings(filter:SettingFilter): Observable<SearchResult<Setting>> {
        //     return this.search<Setting>(this.formatServiceUrl('settings'),filter);
        // }
        SettingService.prototype.querySettings = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        SettingService.prototype.loadSetting = function (module, shortName) {
            var _this = this;
            return this.load(this.formatServiceUrl() + "/" + module + "/" + shortName)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        SettingService.prototype.loadByKey = function (key) {
            var _this = this;
            return this.load(this.formatServiceUrl() + "/load?key=" + key)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        SettingService.prototype.editSetting = function (setting) {
            return this.edit(this.formatServiceUrl(), setting, { method: 'put' });
        };
        SettingService.prototype.deleteSetting = function (module, shortName) {
            return this.http.delete("" + this.formatServiceUrl() + module + "/" + shortName);
        };
        SettingService.prototype.formatServiceUrl = function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.formatUrl("mainUrl") + "/settings" + path;
        };
        return SettingService;
    }(chainBaseAngularClient.RestAspect));
    SettingService.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    SettingService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: chainBaseAngularClient.ConfigService }
    ]; };

    var TAG$4 = 'UserTableComponent';
    var SettingTableComponent = /** @class */ (function () {
        function SettingTableComponent(_service) {
            this._service = _service;
            this.displayedColumns = ['name', 'module', 'value', 'change.date'];
            this.filter = {};
            this.showToolbar = true;
            this.action = new core.EventEmitter();
        }
        SettingTableComponent.prototype.ngOnInit = function () {
            var _a;
            if (this.customColumns && this.customColumns.length > 0) {
                var columnDef = this.customColumns.map(function (c) { return c.columnDef; });
                (_a = this.displayedColumns).push.apply(_a, __spread(columnDef));
            }
        };
        SettingTableComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            var filter = this.filter;
            if (!this.dataSource) {
                this.dataSource = new SettingQueryStore(this._service, this.paginator, this.sort, filter);
                //queryStore(this._service, this.paginator, this.sort, filter);
            }
            if (this.searchElem) {
                rxjs.fromEvent(this.searchElem.nativeElement, 'keyup')
                    .pipe(operators.debounceTime(1000), operators.distinctUntilChanged())
                    .subscribe(function (event) {
                    var value = _this.searchElem.nativeElement.value;
                    if (value == '')
                        value = null;
                    // let filter = this.dataSource.filterSubject.value;
                    var filter = _this.filter;
                    filter.keyword = value;
                    _this.reload();
                });
            }
        };
        SettingTableComponent.prototype.reload = function () {
            this.dataSource.reload();
        };
        SettingTableComponent.prototype.onAction = function (type, payload) {
            this.action.emit({ type: type, value: payload });
        };
        return SettingTableComponent;
    }());
    SettingTableComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'main-setting-table',
                    template: "<div class=\"table-layout-1 setting-table-layout\">\n\n    <ng-content></ng-content>\n\n    <mat-toolbar *ngIf=\"showToolbar\" class=\"primary-300--bg\" fxLayoutAlign=\"space-between center\">\n        <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n        </mat-paginator>\n        <div class=\"field-wrap\">\n            <div class=\"field-box trans-icon\">\n                <input #searchField type=\"text\"/>\n                <button (click)=\"reload()\" type=\"button\">\n                    <i>\n                        <mat-icon>search</mat-icon>\n                    </i>\n                </button>\n            </div>\n        </div>\n    </mat-toolbar>\n\n    <mat-toolbar *ngIf=\"!showToolbar\" class=\"primary-300--bg\" fxLayoutAlign=\"space-between center\">\n        <div fxFlex=\"1 1 auto\"></div>\n        <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n        </mat-paginator>\n    </mat-toolbar>\n\n    <mat-table class=\"table-hover-1\" #table [dataSource]=\"dataSource\" matSort\n               matSortActive=\"change.date\"\n               matSortDirection=\"desc\"\n               matSortDisableClear>\n\n        <!-- SETTINGname Column -->\n        <ng-container matColumnDef=\"name\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.SETTING_NAME' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.name}}</span></mat-cell>\n        </ng-container>\n\n        <!-- firstName Column -->\n        <ng-container matColumnDef=\"module\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.MODULE' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.module}}</span></mat-cell>\n        </ng-container>\n\n        <!-- lastName Column -->\n        <ng-container matColumnDef=\"value\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.VALUE' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.value}}</span></mat-cell>\n        </ng-container>\n        <!-- groups Column -->\n        <ng-container matColumnDef=\"orgId\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.ORG' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.orgId}}</span></mat-cell>\n        </ng-container>\n\n        <!-- created date Column -->\n        <ng-container matColumnDef=\"change.date\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.CHANGE_DATE' | translate}}</mat-header-cell>\n            <!--<mat-cell *matCellDef=\"let row\"><span>{{row?.change?.date | date:'shortDate'}}</span></mat-cell>-->\n            <mat-cell *matCellDef=\"let row\">\n                <base-date [data]=\"row.change?.date\" format=\"date\" formatTip=\"false\"\n                           [matTooltip]=\"row.change?.user\"></base-date>\n            </mat-cell>\n        </ng-container>\n\n        <ng-container matColumnDef=\"created.date\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'COMMON.CREATED_DATE' | translate}}</mat-header-cell>\n            <!--<mat-cell *matCellDef=\"let row\"><span>{{row?.change?.date | date:'shortDate'}}</span></mat-cell>-->\n            <mat-cell *matCellDef=\"let row\">\n                <base-date [data]=\"row.created?.date\" format=\"date\" formatTip=\"false\"\n                           [matTooltip]=\"row.created?.user\"></base-date>\n            </mat-cell>\n        </ng-container>\n\n        <!--custom columns -->\n        <ng-container *ngFor=\"let column of customColumns\" [cdkColumnDef]=\"column.columnDef\">\n            <mat-header-cell *cdkHeaderCellDef>{{ column.header }}</mat-header-cell>\n            <div id=\"observe-wrapper\">\n                <mat-cell *cdkCellDef=\"let row\" [innerHTML]=\"column.cell(row)\"></mat-cell>\n            </div>\n        </ng-container>\n\n\n        <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n        <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('select', row)\">\n        </mat-row>\n\n    </mat-table>\n\n</div>\n\n\n\n",
                    encapsulation: core.ViewEncapsulation.None
                },] }
    ];
    /** @nocollapse */
    SettingTableComponent.ctorParameters = function () { return [
        { type: SettingService }
    ]; };
    SettingTableComponent.propDecorators = {
        displayedColumns: [{ type: core.Input }],
        filter: [{ type: core.Input }],
        dataSource: [{ type: core.Input }],
        showToolbar: [{ type: core.Input }],
        action: [{ type: core.Output }],
        paginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: false },] }],
        sort: [{ type: core.ViewChild, args: [sort.MatSort, { static: false },] }],
        searchElem: [{ type: core.ViewChild, args: ['searchField', { static: false },] }],
        customColumns: [{ type: core.Input }]
    };

    var MainSettingModule = /** @class */ (function () {
        function MainSettingModule() {
        }
        return MainSettingModule;
    }());
    MainSettingModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$1.TranslateModule.forChild({}),
                        forms.ReactiveFormsModule,
                        card.MatCardModule,
                        table.MatTableModule,
                        tooltip.MatTooltipModule,
                        paginator.MatPaginatorModule,
                        sort.MatSortModule,
                        toolbar.MatToolbarModule,
                        button.MatButtonModule,
                        icon.MatIconModule,
                        flexLayout.FlexLayoutModule,
                        forms.FormsModule,
                        chainBaseAngularComp.ChainBaseComp,
                        table$1.CdkTableModule
                    ],
                    declarations: [
                        SettingTableComponent
                    ],
                    exports: [
                        SettingTableComponent
                    ], schemas: [core.NO_ERRORS_SCHEMA]
                },] }
    ];

    /**
     * Data source for the settings table view. This class should
     * encapsulate all logic for fetching and manipulating the displayed data
     * (including sorting, pagination, and filtering).
     */
    var SettingTableDatasource = /** @class */ (function (_super) {
        __extends(SettingTableDatasource, _super);
        function SettingTableDatasource(settingService, paginator, sort, filter) {
            if (filter === void 0) { filter = {}; }
            var _this = _super.call(this, paginator, sort, filter) || this;
            _this.settingService = settingService;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.filter = filter;
            return _this;
        }
        SettingTableDatasource.prototype.queryTable = function () {
            var filter = this.findFilter();
            this.applyFilter(filter);
            return this.settingService.querySettings(filter);
        };
        SettingTableDatasource.prototype.initReloadMutations = function () {
            // server-side filtering
            return [this.filterSubject];
            // all client-side
            //return [];
        };
        SettingTableDatasource.prototype.searchData = function (data) {
            var filter = this.findFilter();
            if (filter.keyword) {
                console.debug(this.constructor.name, "searchData:", filter);
                //let regEx = new RegExp("^"+filter.keyword.replace('*', '.*'), 'i');
                var regEx_1 = new RegExp(filter.keyword.replace('*', '.*'), 'i');
                data = data.filter(function (value) { return regEx_1.test(value.name)
                    || regEx_1.test(value.shortName)
                    || regEx_1.test(value.desc); });
            }
            return _super.prototype.searchData.call(this, data);
        };
        return SettingTableDatasource;
    }(chainBaseAngularStore.QueryTableSource));

    /*
     * Public API Surface of test
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ChainMainLabel = ChainMainLabel;
    exports.GroupService = GroupService;
    exports.GroupTableComponent = GroupTableComponent;
    exports.GroupTableQueryStore = GroupTableQueryStore;
    exports.LabelEditService = LabelEditService;
    exports.LabelTableComponent = LabelTableComponent;
    exports.LabelingComponent = LabelingComponent;
    exports.MainGroupModule = MainGroupModule;
    exports.MainSettingModule = MainSettingModule;
    exports.MainUserModule = MainUserModule;
    exports.SettingQueryStore = SettingQueryStore;
    exports.SettingService = SettingService;
    exports.SettingTableComponent = SettingTableComponent;
    exports.SettingTableDatasource = SettingTableDatasource;
    exports.UserQueryStore = UserQueryStore;
    exports.UserService = UserService;
    exports.UserTableComponent = UserTableComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-main-angular-comp.umd.js.map
