import { Observable } from 'rxjs';
import { HttpClient } from '@angular/common/http';
import { ConfigService, RestAspect } from "@yukawa/chain-base-angular-client";
import { Setting, SettingAspect, SettingFilter } from "@yukawa/chain-main-angular-core";
import { EditResult, QueryResult } from "@yukawa/chain-base-angular-domain";
export declare class SettingService extends RestAspect implements SettingAspect {
    protected http: HttpClient;
    protected configService: ConfigService;
    constructor(http: HttpClient, configService: ConfigService);
    querySettings(filter: SettingFilter | any): Observable<QueryResult<Setting>>;
    loadSetting(module: string, shortName: string): Observable<Setting>;
    loadByKey(key: string): Observable<Setting>;
    editSetting(setting: Setting): Observable<EditResult>;
    deleteSetting(module: string, shortName: string): Observable<EditResult>;
    protected formatServiceUrl(path?: string): string;
}
